/* EPITA - IP - S3/4 */
/* question09 */

#define QNUM 9
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question09.h"

static
void random_fill(int *begin, int *end) {
  for (; begin < end; begin++)
    *begin = random() % 1000;
}

static
void lin_fill(int *begin, int *end) {
  for (int i = 1; begin < end; i++, begin++)
    *begin = i;
}

static
void print_array(int *begin, int *end) {
  for (; begin < end; begin++) {
    printf("| %3d ", *begin);
  }
  printf("|\n");
}

static
void fixed_test(size_t len) {
  printf("Fixed tests:\n");
  int *tab = malloc(len * sizeof (int));
  lin_fill(tab, tab + len);
  printf("  array:\n");
  print_array(tab, tab + len);
  while (next_permutation(tab, len))
    print_array(tab, tab + len);
  free(tab);
}

static
void random_test(size_t len) {
  printf("Random tests:\n");
  int *tab = malloc(len * sizeof (int));
  random_fill(tab, tab + len);
  printf("  array:\n");
  print_array(tab, tab + len);
  int r = next_permutation(tab, len);
  printf("  next_permutation: %d\n", r);
  print_array(tab, tab + len);
  free(tab);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
      random_test(size);
    }
  exit(0);
}
