/* EPITA - IP - S3/4 */
/* question12 */

#define QNUM 12
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question12.h"

static
void random_fill(int *begin, int *end) {
  for (; begin < end; begin++)
    *begin = random() % 20;
}

static
void print_array(int *begin, int *end) {
  for (; begin < end; begin++) {
    printf("| %3d ", *begin);
  }
  printf("|\n");
}


static
void random_test(size_t len) {
  printf("Random tests:\n");
  int *a = calloc(len, sizeof (int));
  int *b = calloc(len, sizeof (int));
  random_fill(a, a + len);
  random_fill(b, b + len);

  printf("  a:\n    ");
  print_array(a, a + len);
  printf("  b:\n    ");
  print_array(b, b + len);

  int r = lex_compare(a, a + len, b, b + len);

  if (r == 0)
    printf("lex_compare: a and b are equal\n");
  else {
    if (r < 0)
      printf("lex_compare: a is smaller than b\n");
    else
      printf("lex_compare: a is bigger than b\n");
  }

  free(a);
  free(b);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      random_test(size);
    }
  exit(0);
}
